//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
	using Neo.ApplicationFramework.Interfaces;
	
	using System.Net;
	using System.Net.Sockets;
	using System.Threading;
	using System.Text;
    
    public partial class UDPServerScript
	{
		public static UdpServer udpServer = null;
		
		static UDPServerScript()
		{
			udpServer = new UdpServer();
		}
		
		public static void Send(string outStr) 
		{
			if (udpServer == null) { return; }
			udpServer.Send(outStr);
		}
    }
	
	public class UdpServer
	{			
		private readonly IPAddress hostIP = IPAddress.Any;
		private readonly int hostPort = 2000;
		
		private UdpClient udpClient = null;
		private Thread clientThread = null;
		private IPEndPoint remoteIPEP = null;
		
		public UdpServer()
		{
			try {
				IPEndPoint ipep = new IPEndPoint(hostIP, hostPort);
				udpClient = new UdpClient(ipep);
				clientThread = new Thread(new ThreadStart(DataReceive));
				clientThread.Start();
			}
			catch (Exception ex) {
				MessageBox.Show("UdpServer(), " + ex.Message);
			}
		}
		
		private void DataReceive()
		{
			try {
				while (true) 
				{
					IPEndPoint IPEP = new IPEndPoint(IPAddress.Any, 0);
					byte[] data = udpClient.Receive(ref IPEP);
					remoteIPEP = IPEP;
					Globals.Tags.Tag1.Value = new string(Encoding.Default.GetChars(data));
				}
			}
			catch (Exception ex) {
				MessageBox.Show("DataReceive(), " + ex.Message);
			}
		}
		
		public void Send(string outStr)
		{
			try {
				if (remoteIPEP == null) { return; }
				udpClient.Send(Encoding.Default.GetBytes(outStr), outStr.Length, remoteIPEP);
			}
			catch (Exception ex) {
				MessageBox.Show("Send(..), " + ex.Message);
			}
		}
	}
}
